/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
// xquake.h: -- X Window System specific Quake header file

#include <ctype.h>
#include <dlfcn.h>
#include <stdarg.h>
#include <signal.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <termios.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/types.h>
#ifdef __linux__
#include <sys/vt.h>
#endif

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>

#include <X11/keysym.h>
#include <X11/cursorfont.h>
#include <X11/xpm.h>

#include <X11/extensions/XShm.h>
#include <X11/extensions/xf86dga.h>
#include <X11/extensions/xf86vmode.h>

#define KEY_MASK (KeyPressMask | KeyReleaseMask)
#define MOUSE_MASK (ButtonPressMask | ButtonReleaseMask | PointerMotionMask | ButtonMotionMask)
#define X_MASK (KEY_MASK | MOUSE_MASK | VisibilityChangeMask | StructureNotifyMask | ExposureMask | FocusChangeMask | EnterWindowMask | LeaveWindowMask)

extern Display *x_disp;
extern Window x_win;

extern qboolean mouse_available; // Mouse available for use
extern qboolean keyboard_grab_active;
extern qboolean mouse_grab_active;
extern qboolean dga_mouse_available;
extern qboolean dga_keyboard_available;
extern qboolean dga_mouse_active;
extern qboolean dga_keyboard_active;

extern int p_mouse_x, p_mouse_y;
extern float mouse_x, mouse_y;
extern int old_mouse_x, old_mouse_y;

extern qboolean win_notify;
extern int win_width;
extern int win_height;
extern int win_x;
extern int win_y;

extern qboolean vidmode_fullscreen; // was vidmode_active

void InitSig(void);
int XLateKey (XKeyEvent *ev);
void IN_GrabMouse (void);
void IN_UngrabMouse (void);
void IN_GrabKeyboard (void);
void IN_UngrabKeyboard (void);

